//---------------------------------------------------------------------------
//
// Name:        RecipientsDlg.h
// Author:      Marcinello
// Created:     2007-09-30 17:43:25
// Description: RecipientsDlg class declaration
//
//---------------------------------------------------------------------------

#ifndef __RECIPIENTSDLG_h__
#define __RECIPIENTSDLG_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

#include "../cfg/config.h"
#include "../common/service/smsmms/gsmmsg.h"
#include "../common/service/gsmmisc.h"
#include "../common/service/backup/gsmback.h"
#include "../common/gsmstate.h"

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/button.h>
#include <wx/listctrl.h>
////Header Include End

////Dialog Style Start
#undef RecipientsDlg_STYLE
#define RecipientsDlg_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class RecipientsDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		RecipientsDlg(wxListCtrl *List2, GSM_StateMachine *s2, GSM_Backup *Backup2, wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Recipients"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = RecipientsDlg_STYLE);
		virtual ~RecipientsDlg();
		void WxButton2Click(wxCommandEvent& event);
		void WxButton1Click(wxCommandEvent& event);
	
	private:
		//Do not add custom control declarations between 
                //GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxButton *WxButton2;
		wxButton *WxButton1;
		wxListCtrl *WxListCtrl1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXBUTTON2 = 1003,
			ID_WXBUTTON1 = 1002,
			ID_WXLISTCTRL1 = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		GSM_Backup *Backup; 
		wxListCtrl *List;
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
