//---------------------------------------------------------------------------
//
// Name:        BackupDlg.cpp
// Author:      Marcinello
// Created:     2007-02-17 22:20:42
// Description: BackupDlg class implementation
//
//---------------------------------------------------------------------------

#include "BackupDlg.h"
#include "shared.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// BackupDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(BackupDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(BackupDlg::OnClose)
	EVT_CHECKBOX(ID_WXCHECKBOX9,BackupDlg::WxCheckBox9Click)
	EVT_CHECKBOX(ID_WXCHECKBOX8,BackupDlg::WxCheckBox8Click)
	EVT_CHECKBOX(ID_WXCHECKBOX7,BackupDlg::WxCheckBox7Click)
	EVT_CHECKBOX(ID_WXCHECKBOX6,BackupDlg::WxCheckBox6Click)
	EVT_BUTTON(ID_WXBUTTON4,BackupDlg::WxButton4Click)
	EVT_BUTTON(ID_WXBUTTON3,BackupDlg::WxButton3Click)
	EVT_BUTTON(ID_WXBUTTON2,BackupDlg::WxButton2Click)
	EVT_CHECKBOX(ID_WXCHECKBOX5,BackupDlg::WxCheckBox5Click)
	EVT_CHECKBOX(ID_WXCHECKBOX4,BackupDlg::WxCheckBox4Click)
	EVT_CHECKBOX(ID_WXCHECKBOX3,BackupDlg::WxCheckBox3Click)
	EVT_CHECKBOX(ID_WXCHECKBOX2,BackupDlg::WxCheckBox2Click)
	EVT_COMBOBOX(ID_WXCOMBOBOX1,BackupDlg::WxComboBox1Selected)
	EVT_BUTTON(ID_WXBUTTON1,BackupDlg::WxButton1Click)
	EVT_CHECKBOX(ID_WXCHECKBOX1,BackupDlg::WxCheckBox1Click)
END_EVENT_TABLE()
////Event Table End

BackupDlg::BackupDlg(GSM_Backup_FileFormatFunctions *Func2, wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
    Func = Func2;

	CreateGUIControls();
	
	SetTitle(title);
    
    WxComboBox1->Select(0);
    WxButton3->Enable(FALSE);
    
    WxCheckBox1->Enable(Func->PhonePBK);    
    WxCheckBox2->Enable(Func->SIMPBK);
    WxCheckBox3->Enable(Func->Calendar);
    WxCheckBox4->Enable(Func->Notes);
    WxCheckBox5->Enable(Func->ToDo);
    WxCheckBox6->Enable(Func->SMS);
    WxCheckBox7->Enable(Func->MMS);
    WxCheckBox8->Enable(Func->WAPBookmarks);
    WxCheckBox9->Enable(Func->FMStations);
}

BackupDlg::~BackupDlg()
{
} 

void BackupDlg::CreateGUIControls()
{
	//Do not add custom code between
        //GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("Untitled1"));
	SetIcon(wxNullIcon);
	SetSize(8,8,419,502);
	Center();
	

	WxCheckBox9 = new wxCheckBox(this, ID_WXCHECKBOX9, wxT("Phone FM stations"), wxPoint(23,314), wxSize(297,26), 0, wxDefaultValidator, wxT("WxCheckBox9"));
	WxCheckBox9->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox8 = new wxCheckBox(this, ID_WXCHECKBOX8, wxT("Phone WAP bookmarks"), wxPoint(23,286), wxSize(280,26), 0, wxDefaultValidator, wxT("WxCheckBox8"));
	WxCheckBox8->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox7 = new wxCheckBox(this, ID_WXCHECKBOX7, wxT("Phone MMS"), wxPoint(23,255), wxSize(242,30), 0, wxDefaultValidator, wxT("WxCheckBox7"));
	WxCheckBox7->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox6 = new wxCheckBox(this, ID_WXCHECKBOX6, wxT("SIM/phone SMS"), wxPoint(23,375), wxSize(195,23), 0, wxDefaultValidator, wxT("WxCheckBox6"));
	WxCheckBox6->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxButton4 = new wxButton(this, ID_WXBUTTON4, wxT("Cancel"), wxPoint(258,418), wxSize(142,39), 0, wxDefaultValidator, wxT("WxButton4"));
	WxButton4->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxButton3 = new wxButton(this, ID_WXBUTTON3, wxT("OK"), wxPoint(9,418), wxSize(142,37), 0, wxDefaultValidator, wxT("WxButton3"));
	WxButton3->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Destination"), wxPoint(25,37), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxButton2 = new wxButton(this, ID_WXBUTTON2, wxT("Unselect all"), wxPoint(282,163), wxSize(98,31), 0, wxDefaultValidator, wxT("WxButton2"));
	WxButton2->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox5 = new wxCheckBox(this, ID_WXCHECKBOX5, wxT("Phone ToDo"), wxPoint(23,229), wxSize(245,25), 0, wxDefaultValidator, wxT("WxCheckBox5"));
	WxCheckBox5->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox4 = new wxCheckBox(this, ID_WXCHECKBOX4, wxT("Phone notes"), wxPoint(23,202), wxSize(212,26), 0, wxDefaultValidator, wxT("WxCheckBox4"));
	WxCheckBox4->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox3 = new wxCheckBox(this, ID_WXCHECKBOX3, wxT("Phone calendar"), wxPoint(23,175), wxSize(206,27), 0, wxDefaultValidator, wxT("WxCheckBox3"));
	WxCheckBox3->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox2 = new wxCheckBox(this, ID_WXCHECKBOX2, wxT("SIM phonebook"), wxPoint(23,111), wxSize(154,26), 0, wxDefaultValidator, wxT("WxCheckBox2"));
	WxCheckBox2->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	wxArrayString arrayStringFor_WxComboBox1;
	arrayStringFor_WxComboBox1.Add(wxT("Gammu backup file"));
	arrayStringFor_WxComboBox1.Add(wxT("XML file (no restore yet !)"));
	WxComboBox1 = new wxComboBox(this, ID_WXCOMBOBOX1, wxT("WxComboBox1"), wxPoint(122,32), wxSize(261,28), arrayStringFor_WxComboBox1, wxCB_DROPDOWN | wxCB_READONLY, wxDefaultValidator, wxT("WxComboBox1"));
	WxComboBox1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxButton1 = new wxButton(this, ID_WXBUTTON1, wxT("Select all"), wxPoint(282,125), wxSize(98,30), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxCheckBox1 = new wxCheckBox(this, ID_WXCHECKBOX1, wxT("Phone phonebook"), wxPoint(23,148), wxSize(211,27), 0, wxDefaultValidator, wxT("WxCheckBox1"));
	WxCheckBox1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxStaticBox1 = new wxStaticBox(this, ID_WXSTATICBOX1, wxT("Features"), wxPoint(9,86), wxSize(391,323));
	WxStaticBox1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));

	WxStaticBox2 = new wxStaticBox(this, ID_WXSTATICBOX2, wxT("File"), wxPoint(9,0), wxSize(391,82));
	WxStaticBox2->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE));
	////GUI Items Creation End
}

void BackupDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxButton3Click
 */
void BackupDlg::WxButton3Click(wxCommandEvent& event)
{
	EndModal(wxID_OK);
}

/*
 * WxButton4Click
 */
void BackupDlg::WxButton4Click(wxCommandEvent& event)
{
	EndModal(wxID_CANCEL);
}

/*
 * WxComboBox1Selected
 */
void BackupDlg::WxComboBox1Selected(wxCommandEvent& event )
{
	GSM_Backup                     Backup;
	GSM_Backup_FileFormatFunctions Func;
	
	if (WxComboBox1->GetSelection()==0) {
    	Backup.GetFileFunctions(Backup_Gammu, &Func);
    } else {
    	Backup.GetFileFunctions(Backup_XML, &Func);
    }
	
	WxCheckBox1->Enable(Func.PhonePBK);
	WxCheckBox2->Enable(Func.SIMPBK);
	WxCheckBox3->Enable(Func.Calendar);	
	WxCheckBox4->Enable(Func.Notes);
	WxCheckBox5->Enable(Func.ToDo);
	WxCheckBox6->Enable(Func.SMS);
	WxCheckBox7->Enable(Func.MMS);
    WxCheckBox8->Enable(Func.WAPBookmarks);
    WxCheckBox9->Enable(Func.FMStations);
	Check();	
}

/*
 * WxButton1Click
 */
void BackupDlg::WxButton1Click(wxCommandEvent& event)
{
	if (WxCheckBox1->IsEnabled()) WxCheckBox1->SetValue(TRUE);
	if (WxCheckBox2->IsEnabled()) WxCheckBox2->SetValue(TRUE);
	if (WxCheckBox3->IsEnabled()) WxCheckBox3->SetValue(TRUE);
	if (WxCheckBox4->IsEnabled()) WxCheckBox4->SetValue(TRUE);
	if (WxCheckBox5->IsEnabled()) WxCheckBox5->SetValue(TRUE);
	if (WxCheckBox6->IsEnabled()) WxCheckBox6->SetValue(TRUE);
	if (WxCheckBox7->IsEnabled()) WxCheckBox7->SetValue(TRUE);
	if (WxCheckBox8->IsEnabled()) WxCheckBox8->SetValue(TRUE);
	if (WxCheckBox9->IsEnabled()) WxCheckBox9->SetValue(TRUE);
	Check();
}

/*
 * WxButton2Click
 */
void BackupDlg::WxButton2Click(wxCommandEvent& event)
{
	WxCheckBox1->SetValue(FALSE);
	WxCheckBox2->SetValue(FALSE);
	WxCheckBox3->SetValue(FALSE);
	WxCheckBox4->SetValue(FALSE);
	WxCheckBox5->SetValue(FALSE);
	WxCheckBox6->SetValue(FALSE);
	WxCheckBox7->SetValue(FALSE);
	WxCheckBox8->SetValue(FALSE);
	WxCheckBox9->SetValue(FALSE);
	Check();
}

void BackupDlg::Check()
{
	Func->PhonePBK = WxCheckBox1->GetValue();
    Func->SIMPBK = WxCheckBox2->GetValue();
    Func->Calendar = WxCheckBox3->GetValue();
	Func->Notes = WxCheckBox4->GetValue();
	Func->ToDo = WxCheckBox5->GetValue();
	Func->SMS = WxCheckBox6->GetValue();
	Func->MMS = WxCheckBox7->GetValue();
	Func->WAPBookmarks = WxCheckBox8->GetValue();
	Func->FMStations = WxCheckBox8->GetValue();
	
    WxButton3->Enable(TRUE);
    if (!WxCheckBox1->GetValue() &&
	    !WxCheckBox2->GetValue() &&
    	!WxCheckBox3->GetValue() &&
        !WxCheckBox4->GetValue() &&
        !WxCheckBox5->GetValue() &&
        !WxCheckBox6->GetValue() &&
        !WxCheckBox7->GetValue() &&
        !WxCheckBox8->GetValue() &&
        !WxCheckBox9->GetValue()) {
            //fixme
    	WxButton3->Enable(FALSE);
    }    
}

/*
 * WxCheckBox1Click
 */
void BackupDlg::WxCheckBox1Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox2Click
 */
void BackupDlg::WxCheckBox2Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox3Click
 */
void BackupDlg::WxCheckBox3Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox4Click
 */
void BackupDlg::WxCheckBox4Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox5Click
 */
void BackupDlg::WxCheckBox5Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox6Click
 */
void BackupDlg::WxCheckBox6Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox7Click
 */
void BackupDlg::WxCheckBox7Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox8Click
 */
void BackupDlg::WxCheckBox8Click(wxCommandEvent& event)
{
	Check();
}

/*
 * WxCheckBox9Click
 */
void BackupDlg::WxCheckBox9Click(wxCommandEvent& event)
{
	Check();
}
